#include "i2clcd.h"
#include "Arduino.h"
#include "Wire.h"

i2clcd::i2clcd() {
	_addr = 0x50;
	_cltdata = 0x80;
	_br =0x13;
	_v5or33 = 3;
    Wire.begin();
}
i2clcd::i2clcd(byte i2cadr) {
	_addr = i2cadr;
	_cltdata = chkcltdata(i2cadr);
	_br = 0x13;
	_v5or33 = 3;
	Wire.begin();
}
i2clcd::i2clcd(byte i2cadr,byte v5or33) {
	_addr = i2cadr;
	_cltdata = chkcltdata(i2cadr);
	_v5or33 = v5or33;
	if (_v5or33 == 5) {
		_br = 0x23;
	}
	else {
        _br =0x13;
	}
	Wire.begin();
}
i2clcd::i2clcd(byte i2cadr,byte v5or33,byte lbr){
	_addr = i2cadr;
	_cltdata = chkcltdata(i2cadr);
	_br = lbr;
	_v5or33 = v5or33;
	Wire.begin();
}
byte i2clcd::chkcltdata(byte adr) {
	if (adr == 0x50) {
		return  0x80;
	}
	else {
		return  0x40;
	}
}
int i2clcd::i2cwritecmd(byte cmd){
  Wire.beginTransmission(_addr);
  Wire.write(0x00);
  Wire.write(cmd);
  return Wire.endTransmission();
}
int i2clcd::i2cwritedata(byte data){
  Wire.beginTransmission(_addr);
  Wire.write(_cltdata);
  Wire.write(data);
  return Wire.endTransmission();
}
void i2clcd::lcdcu_set(int x, int y) {
  byte ca = (x + y * 0x40) | (0x80);  i2cwritecmd(ca);
}
void i2clcd::lcdclear() {
  i2cwritecmd(0x01);  delay(1);
}
void i2clcd::lcdhome() {
  i2cwritecmd(0x02);  delay(1);
}
void i2clcd::dsift_l() {
  i2cwritecmd(0x18);
}
void i2clcd::dsift_r() {
  i2cwritecmd(0x1C);
}
void i2clcd::init_lcd() {
	byte bon = 0x04;
	byte powercmd = 0;
	delay(145);
	i2cwritecmd(0x38); delay(1);//@oCgEf[^8rbgPʂŎ󂯓nݒ
	i2cwritecmd(0x38); delay(1); //@Ô߂̓ݒJԂ
	if (_addr == 0x3E) {
		byte contrast = (0x70 | (_br & 0x0F));
     	if (_v5or33 == 5) {
	    		bon = 0x00;
		}
		else {
				bon = 0x04;
		}
    	powercmd = (0x50 | (bon | (_br >> 4)));
		i2cwritecmd(0x39);  delay(1);
		i2cwritecmd(0x14);  delay(1);
		i2cwritecmd(contrast);  delay(1);
		i2cwritecmd(powercmd);  delay(2);
		i2cwritecmd(0x6C);  delay(300);
		i2cwritecmd(0x38);  delay(1);
	}
	i2cwritecmd(0x01);  delay(2);
	i2cwritecmd(0x0C);  delay(2);
}

void i2clcd::i2cprint( String pdata) {
  int n = pdata.length();
  for (int i = 0; i < n; i = i + 1) {
    i2cwritedata( pdata.charAt(i));
    delay(1);
  }
}
